<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>8. lekce</title>
</head>
<body>
    
    <div id="root"></div>

    <style>
        .hide {
            display: none;
        }

        .product {
            display: flex;
            align-items: center;
            flex-direction: column;
            font-size: 24px;
            gap: 10px;
            margin-bottom: 20px;
        }
    </style>

    <script>
        (async function() {
            const delay = ms => new Promise(res => setTimeout(res, ms));

            const root = document.getElementById("root");

            const url = "https://raw.githubusercontent.com/pavelprokes/js-demo-test/master/vzdelani-budoucnosti/javascript/products.json"

            async function getProducts() {
                await delay(5000);

                const data = await fetch(url)
                    .catch(error => {
                        console.log(`Error when fetching products from ${url} error: ${JSON(error)}.`);
                    })
                    .then(response => {
                        const jsonData = response.json();
                        return jsonData;
                    });

                return data;
            }
          
            function createLoader() {
                const loaderElement = document.createElement("div");
                loaderElement.setAttribute("id", "loader");
                const loaderText = document.createTextNode("Please wait ...");
                loaderElement.appendChild(loaderText);
                root.appendChild(loaderElement);
            }

            function hideLoader() {
                const loader = document.getElementById("loader");
                loader.classList.add("hide");
            }

            function renderProductsList(list) {
                const ulElement = document.createElement("ul");

                list.forEach((product, index) => {
                    const liElement = document.createElement("li");
                    liElement.classList.add("product");
                    const textTitle = document.createTextNode(product.title);

                    const imageElement = document.createElement("img");
                    imageElement.setAttribute("src", product.thumbnail);
                    imageElement.setAttribute("height", 200);

                    liElement.appendChild(textTitle);
                    liElement.appendChild(imageElement);
                    ulElement.appendChild(liElement);
                })

                root.appendChild(ulElement);
            }

            createLoader();
            const data = await getProducts();
            
            renderProductsList(data.products);

            hideLoader();



        })();
    </script>

</body>
</html>